<?php

namespace RxConnexionBundle\Entity;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="RxConnexionBundle\Repository\TransferInventoryDeliveryItemRepository")
 * @ORM\Table(name="transfer_inventory_delivery_item")
 * @ORM\HasLifecycleCallbacks()
 */

class TransferInventoryDeliveryItemEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="quantity", type="decimal", precision=12, scale=2)
     */
    protected $quantity;

    /**
     * @ORM\Column(name="note", type="string", nullable=true)
     */
    protected $note;

    /**
     * @ORM\Column(name="created_by", type="string", length=50)
     */
    protected $createdBy;

    /**
     * @ORM\Column(name="created_at", type="datetime")
     */
    protected $createdAt;

    /**
     * @ORM\Column(name="updated_by", type="string", length=50)
     */
    protected $updatedBy;

    /**
     * @ORM\Column(name="updated_at", type="datetime")
     */
    protected $updatedAt;

    /**
     * @ORM\ManyToOne(targetEntity="TransferInventoryDeliveryEntity", inversedBy="transferInventoryDeliveryItems")
     * @ORM\JoinColumn(name="transfer_inventory_delivery_id", referencedColumnName="id")
     */
    protected $transferInventoryDelivery;

    /**
     * @ORM\ManyToOne(targetEntity="TransferInventoryItemEntity", inversedBy="transferInventoryDeliveryItems")
     * @ORM\JoinColumn(name="transfer_inventory_item_id", referencedColumnName="id")
     */
    protected $transferInventoryItem;

    /**
     * @ORM\ManyToOne(targetEntity="InventoryEntity", inversedBy="transferInventoryDeliveryItems")
     * @ORM\JoinColumn(name="inventory_id", referencedColumnName="id")
     */
    protected $inventory;

    /**
     * @ORM\OneToMany(targetEntity="InventoryMovementEntity", mappedBy="transferInventoryDeliveryItem", cascade={"remove"})
     */
    protected $inventoryMovements;

	/**
	 * @ORM\OneToMany(targetEntity="TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity", mappedBy="transferInventoryDeliveryItem", cascade={"remove"})
	 */
	protected $transferInventoryDeliveryItemTransferInventoryItemInvSerialNos;

    /**
     * Set createdAt
     *
     * @ORM\PrePersist
     */
    public function setCreatedAtValue()
    {
        $this->createdBy = isSet($_COOKIE['username']) ? $_COOKIE['username'] : 'System';
        $this->createdAt = new \DateTime();
        $this->updatedBy = isSet($_COOKIE['username']) ? $_COOKIE['username'] : 'System';
        $this->updatedAt = new \DateTime();
    }

    /**
     * Set updatedAt
     *
     * @ORM\PreUpdate
     */
    public function setUpdatedAtValue()
    {
        $this->updatedBy = $_COOKIE['username'];
        $this->updatedAt = new \DateTime();
    }

    public function __construct()
    {
        $this->inventoryMovements = new ArrayCollection();
        $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos = new ArrayCollection();
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					User Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

	public function cascadePersistRemoveTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos_byTransferInventoryItemInvSerialNos(ArrayCollection $transferInventoryItemInventorySerialNos, ObjectManager $em)
	{

		/**@var TransferInventoryItemInventorySerialNoEntity $transferInventoryItemInventorySerialNo*/
		/**@var TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo*/
		foreach ($transferInventoryItemInventorySerialNos as $transferInventoryItemInventorySerialNo) {
			$exists = false;
			foreach ($this->getTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos() as $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo) {
				// IF EXISTS, SKIP PERSIST BECAUSE IT IS ALREADY IN THE ONE TO MANY
				if($transferInventoryDeliveryItemTransferInventoryItemInvSerialNo->getTransferInventoryItemInventorySerialNo() === $transferInventoryItemInventorySerialNo) {
					$exists = true;
					break;
				}
			}

			// IF NOT FOUND IN THE EXISTING ONE TO MANY, ADD IT
			if(!$exists) {
				$new = new TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity();
				$new->setTransferInventoryDeliveryItem($this);
				$new->setTransferInventoryItemInventorySerialNo($transferInventoryItemInventorySerialNo);
				$this->addTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos($new);
				$em->persist($new);
			}

		}

		foreach ($this->getTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos() as $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo) {
			$exists = false;

			foreach ($transferInventoryItemInventorySerialNos as $transferInventoryItemInventorySerialNo) {
				// IF EXISTS, SKIP CASCADE BECAUSE IT IS STILL IN THE ONE TO MANY
				if($transferInventoryDeliveryItemTransferInventoryItemInvSerialNo->getTransferInventoryItemInventorySerialNo() === $transferInventoryItemInventorySerialNo) {
					$exists = true;
					break;
				}
			}

			// IF NOT FOUND IN THE SUBMITTED ARRAY COLLECTION, REMOVE IT
			if(!$exists) {
				$transferInventoryDeliveryItemTransferInventoryItemInvSerialNo->getTransferInventoryItemInventorySerialNo()->getInventorySerialNo()->setStatus(InventorySerialNoEntity::STATUS_1);
				$this->removeTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos($transferInventoryDeliveryItemTransferInventoryItemInvSerialNo);
				$em->remove($transferInventoryDeliveryItemTransferInventoryItemInvSerialNo);
			}

		}


		return $this;
	}


    /*--------------------------------------------------------------------------------------------------------*/
    /*					Setters and Getters																	  */
    /*--------------------------------------------------------------------------------------------------------*/


    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set quantity
     *
     * @param string $quantity
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setQuantity($quantity)
    {
        $this->quantity = $quantity;

        return $this;
    }

    /**
     * Get quantity
     *
     * @return float
     */
    public function getQuantity()
    {
        return $this->quantity;
    }

    /**
     * Set note
     *
     * @param string $note
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setNote($note)
    {
        $this->note = $note;

        return $this;
    }

    /**
     * Get note
     *
     * @return string
     */
    public function getNote()
    {
        return $this->note;
    }

    /**
     * Set createdBy
     *
     * @param string $createdBy
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setCreatedBy($createdBy)
    {
        $this->createdBy = $createdBy;

        return $this;
    }

    /**
     * Get createdBy
     *
     * @return string
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set updatedBy
     *
     * @param string $updatedBy
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setUpdatedBy($updatedBy)
    {
        $this->updatedBy = $updatedBy;

        return $this;
    }

    /**
     * Get updatedBy
     *
     * @return string
     */
    public function getUpdatedBy()
    {
        return $this->updatedBy;
    }

    /**
     * Set updatedAt
     *
     * @param \DateTime $updatedAt
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * Get updatedAt
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }

    /**
     * Set transferInventoryDelivery
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryDeliveryEntity $transferInventoryDelivery
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setTransferInventoryDelivery(\RxConnexionBundle\Entity\TransferInventoryDeliveryEntity $transferInventoryDelivery = null)
    {
        $this->transferInventoryDelivery = $transferInventoryDelivery;

        return $this;
    }

    /**
     * Get transferInventoryDelivery
     *
     * @return \RxConnexionBundle\Entity\TransferInventoryDeliveryEntity
     */
    public function getTransferInventoryDelivery()
    {
        return $this->transferInventoryDelivery;
    }

    /**
     * Set transferInventoryItem
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryItemEntity $transferInventoryItem
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setTransferInventoryItem(\RxConnexionBundle\Entity\TransferInventoryItemEntity $transferInventoryItem = null)
    {
        $this->transferInventoryItem = $transferInventoryItem;

        return $this;
    }

    /**
     * Get transferInventoryItem
     *
     * @return \RxConnexionBundle\Entity\TransferInventoryItemEntity
     */
    public function getTransferInventoryItem()
    {
        return $this->transferInventoryItem;
    }

    /**
     * Set inventory
     *
     * @param \RxConnexionBundle\Entity\InventoryEntity $inventory
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function setInventory(\RxConnexionBundle\Entity\InventoryEntity $inventory = null)
    {
        $this->inventory = $inventory;

        return $this;
    }

    /**
     * Get inventory
     *
     * @return \RxConnexionBundle\Entity\InventoryEntity
     */
    public function getInventory()
    {
        return $this->inventory;
    }

    /**
     * Add inventoryMovement
     *
     * @param \RxConnexionBundle\Entity\InventoryMovementEntity $inventoryMovement
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function addInventoryMovement(\RxConnexionBundle\Entity\InventoryMovementEntity $inventoryMovement)
    {
        $this->inventoryMovements[] = $inventoryMovement;

        return $this;
    }

    /**
     * Remove inventoryMovement
     *
     * @param \RxConnexionBundle\Entity\InventoryMovementEntity $inventoryMovement
     */
    public function removeInventoryMovement(\RxConnexionBundle\Entity\InventoryMovementEntity $inventoryMovement)
    {
        $this->inventoryMovements->removeElement($inventoryMovement);
    }

    /**
     * Get inventoryMovements
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getInventoryMovements()
    {
        return $this->inventoryMovements;
    }

    /**
     * Add transferInventoryDeliveryItemTransferInventoryItemInvSerialNos
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryTransInvItemInvSerialNo
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function addTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos(\RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryTransInvItemInvSerialNo)
    {
        $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos[] = $transferInventoryDeliveryTransInvItemInvSerialNo;

        return $this;
    }

    /**
     * Remove transferInventoryDeliveryItemTransferInventoryItemInvSerialNos
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryTransInvItemInvSerialNo
     */
    public function removeTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos(\RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryTransInvItemInvSerialNo)
    {
        $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos->removeElement($transferInventoryDeliveryTransInvItemInvSerialNo);
    }

    /**
     * Get transferInventoryDeliveryTransInvItemInvSerialNos
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getTransferInventoryDeliveryItemTransferInventoryItemInvSerialNos()
    {
        return $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos;
    }

    /**
     * Add transferInventoryDeliveryItemTransferInventoryItemInvSerialNo
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo
     *
     * @return TransferInventoryDeliveryItemEntity
     */
    public function addTransferInventoryDeliveryItemTransferInventoryItemInvSerialNo(\RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo)
    {
        $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos[] = $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo;

        return $this;
    }

    /**
     * Remove transferInventoryDeliveryItemTransferInventoryItemInvSerialNo
     *
     * @param \RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo
     */
    public function removeTransferInventoryDeliveryItemTransferInventoryItemInvSerialNo(\RxConnexionBundle\Entity\TransferInventoryDeliveryItemTransferInventoryItemInvSerialNoEntity $transferInventoryDeliveryItemTransferInventoryItemInvSerialNo)
    {
        $this->transferInventoryDeliveryItemTransferInventoryItemInvSerialNos->removeElement($transferInventoryDeliveryItemTransferInventoryItemInvSerialNo);
    }
}
